<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: find_max_factor_graph_nmplp_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_b4000b80df5557ad6c393bb703a96248.html">optimization</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">find_max_factor_graph_nmplp_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_FIND_MAX_FACTOR_GRAPH_nMPLP_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_FIND_MAX_FACTOR_GRAPH_nMPLP_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;{</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="keyword">class </span>map_problem </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">class </span>node_iterator</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        {</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;            node_iterator(</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;            );</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            node_iterator(</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                <span class="keyword">const</span> node_iterator&amp; item</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            );</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            node_iterator&amp; operator= (</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;                <span class="keyword">const</span> node_iterator&amp; item</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            );</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            <span class="keywordtype">bool</span> operator== (</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                <span class="keyword">const</span> node_iterator&amp; item</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            ) <span class="keyword">const</span>; </div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordtype">bool</span> operator!= (</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;                <span class="keyword">const</span> node_iterator&amp; item</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            node_iterator&amp; operator++(</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            );</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        };</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160; </div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keyword">class </span>neighbor_iterator</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            neighbor_iterator(</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            ); </div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;            neighbor_iterator(</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;                <span class="keyword">const</span> neighbor_iterator&amp; item</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            );</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            neighbor_iterator&amp; operator= (</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;                <span class="keyword">const</span> neighbor_iterator&amp; item</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            );</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;            <span class="keywordtype">bool</span> operator== (</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                <span class="keyword">const</span> neighbor_iterator&amp; item</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            ) <span class="keyword">const</span>; </div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordtype">bool</span> operator!= (</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                <span class="keyword">const</span> neighbor_iterator&amp; item</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            neighbor_iterator&amp; operator++(</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            ); </div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        };</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160; </div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> number_of_nodes (</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        node_iterator begin(</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        node_iterator end(</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        neighbor_iterator begin(</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="keyword">const</span> node_iterator&amp; it</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        neighbor_iterator begin(</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            <span class="keyword">const</span> neighbor_iterator&amp; it</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        neighbor_iterator end(</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;            <span class="keyword">const</span> node_iterator&amp; it</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        neighbor_iterator end(</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;            <span class="keyword">const</span> neighbor_iterator&amp; it</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> node_id (</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;            <span class="keyword">const</span> node_iterator&amp; it</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> node_id (</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keyword">const</span> neighbor_iterator&amp; it</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_states (</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;            <span class="keyword">const</span> node_iterator&amp; it</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_states (</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            <span class="keyword">const</span> neighbor_iterator&amp; it</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="comment">// The next four functions all have the same contract.</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="keywordtype">double</span> factor_value (<span class="keyword">const</span> node_iterator&amp; it1,     <span class="keyword">const</span> node_iterator&amp; it2,     <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s1, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s2) <span class="keyword">const</span>;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keywordtype">double</span> factor_value (<span class="keyword">const</span> neighbor_iterator&amp; it1, <span class="keyword">const</span> node_iterator&amp; it2,     <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s1, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s2) <span class="keyword">const</span>;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        <span class="keywordtype">double</span> factor_value (<span class="keyword">const</span> node_iterator&amp; it1,     <span class="keyword">const</span> neighbor_iterator&amp; it2, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s1, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s2) <span class="keyword">const</span>;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <span class="keywordtype">double</span> factor_value (<span class="keyword">const</span> neighbor_iterator&amp; it1, <span class="keyword">const</span> neighbor_iterator&amp; it2, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s1, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> s2) <span class="keyword">const</span>;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    };</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160; </div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160; </div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keyword">typename</span> map_problem</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;        &gt;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <span class="keywordtype">void</span> find_max_factor_graph_nmplp (</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keyword">const</span> map_problem&amp; prob,</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        std::vector&lt;unsigned long&gt;&amp; map_assignment,</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_iter,</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keywordtype">double</span> eps</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    );</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160; </div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;}</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160; </div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;<span class="preprocessor">#endif // DLIB_FIND_MAX_FACTOR_GRAPH_nMPLP_ABSTRACT_Hh_</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160; </div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
